package com.rf.psychological.scale.resultBusiness.scaleResult;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.rf.psychological.utils.Constant;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

/**
 * @author zsy
 * @description:孤独量表
 * @date 2021/7/20 15:55
 */
public class UCLAScale extends BaseScale{

    public UCLAScale(JSONArray jsonArray, JSONObject resultJson) {
        super(jsonArray, resultJson);
    }

    public  JSONObject scaleCalculate() throws Exception {
        //得分
        int score = 0;
        for (int i = 0; i < jsonArray.size(); i++) {
            JSONObject jsonObject1 = jsonArray.getJSONObject(i);
            if (jsonObject1.getString("scoreDirection").equals("1")) {
                if (jsonObject1.getString("checkItems").equals("从不")) {
                    score += 1;
                } else if (jsonObject1.getString("checkItems").equals("很少")) {
                    score += 2;
                } else if (jsonObject1.getString("checkItems").equals("有时")) {
                    score += 3;
                } else if (jsonObject1.getString("checkItems").equals("一直")) {
                    score += 4;
                }
            } else if (jsonObject1.getString("scoreDirection").equals("0")){
                if (jsonObject1.getString("checkItems").equals("从不")) {
                    score += 4;
                } else if (jsonObject1.getString("checkItems").equals("很少")) {
                    score += 3;
                } else if (jsonObject1.getString("checkItems").equals("有时")) {
                    score += 2;
                } else if (jsonObject1.getString("checkItems").equals("一直")) {
                    score += 1;
                }

            }
        }
        //得分列表
        Map<String, String> resultMap = new LinkedHashMap<>();
        resultMap.put("总分", String.valueOf(score));
        resultJson.put("总分", String.valueOf(score));

        //根据得分判断症状
        if (score >= 44){
            resultMap.put("结论", "高度孤独");
            resultJson.put("结论", "高度孤独");
        }else if (score >= 39 && score < 44){
            resultMap.put("结论", "一般偏上孤独");
            resultJson.put("结论", "一般偏上孤独");
        }else if (score >= 33 && score < 39){
            resultMap.put("结论", "中间水平");
            resultJson.put("结论", "中间水平");
        }else if (score >= 28 && score < 33){
            resultMap.put("结论", "一般偏下孤独");
            resultJson.put("结论", "一般偏下孤独");
        }else if (score < 28){
            resultMap.put("结论", "低度孤独");
            resultJson.put("结论", "低度孤独");
        }

        List<Map<String,String>> resultMapList = new ArrayList<>();
        resultMapList.add(resultMap);

        JSONObject returnJson = new JSONObject(true);
        returnJson.put("resultMapList",resultMapList);
        returnJson.put("scaleName",Constant.SHEET_NAME_UCLA);
        returnJson.put("resultJson",resultJson);

        return returnJson;
    }
}
